## rumur 2020.01.27

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

project(rumur LANGUAGES CXX)

# This seems to be some magic to get libraries to install correctly.
include(GNUInstallDirs)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -W -Wall -Wextra -Wwrite-strings -Wmissing-declarations -Wshadow")

# enable even more warnings if the compiler supports them
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wcast-qual HAS_WARNING_CAST_QUAL)
if(HAS_WARNING_CAST_QUAL)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-qual")
endif()
CHECK_CXX_COMPILER_FLAG(-Wcast-align HAS_WARNING_CAST_ALIGN)
if(HAS_WARNING_CAST_ALIGN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
endif()
CHECK_CXX_COMPILER_FLAG(-Wstrict-aliasing=1 HAS_WARNING_STRICT_ALIASING_1)
if(HAS_WARNING_STRICT_ALIASING_1)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wstrict-aliasing=1")
endif()
CHECK_CXX_COMPILER_FLAG(-Wpointer-arith HAS_WARNING_POINTER_ARITH)
if(HAS_WARNING_POINTER_ARITH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpointer-arith")
endif()

# Enable --as-needed, present on GNU ld on Linux, to minimise dependencies.
if(${CMAKE_SYSTEM_NAME} STREQUAL "Linux")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
endif()

add_subdirectory(ast-dump)
add_subdirectory(librumur)
add_subdirectory(rumur)

enable_testing()
add_test(tests env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/ast-dump:$ENV{PATH} ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py)

=== ast-dump/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/rumur-ast-dump.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/rumur-ast-dump.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(rumur-ast-dump
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.cc
  src/main.cc
  src/XMLPrinter.cc)

target_include_directories(rumur-ast-dump
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(rumur-ast-dump
  librumur)

# Compress manpages
add_custom_target(man-ast-dump
  ALL
  DEPENDS rumur-ast-dump.1.gz)
add_custom_command(
  OUTPUT rumur-ast-dump.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/rumur-ast-dump.1 >"${CMAKE_CURRENT_BINARY_DIR}/rumur-ast-dump.1.gz"
  MAIN_DEPENDENCY doc/rumur-ast-dump.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS rumur-ast-dump
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/rumur-ast-dump.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== debian/changelog ===
rumur (2020.01.27-1) unstable; urgency=medium

  * New upstream release.

  * Add strace as a build dependency.

  * Update Standards-Version from 4.4.1 to 4.5.0.

  * Some robustness improvements to the autopkgtests.

  * RUMUR_VERSION variable in rules is now set automatically from the changelog
    using pkg-info.mk support.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Mon, 27 Jan 2020 18:26:29 -0800

rumur (2020.01.11-1) unstable; urgency=medium

  * New upstream release.

  * Update autopkgtest tests to test the installed binaries and library.
    Previously this incorrectly ran the upstream test suite.

  * Update RUMUR_VERSION variable in rules from 2019.12.22-1 to 2020.01.11-1.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 12 Jan 2020 10:00:20 -0800

rumur (2019.12.22-1) unstable; urgency=medium

  * New upstream release.

  * Switch all Python references to Python 3. Closes: #943253.

  * Update Standards-Version from 4.3.0 to 4.4.1.

  * Remove xxd dependency. Upstream changed to no longer rely on xxd.

  * Correct Vcs-Git URL typo.

  * Remove manpages file. Upstream already installed man pages at the correct
    path, so this file was doing unnecessary duplicate work.

  * Integrate upstream test suite into Debian packaging steps as a Test-Command.

  * Update RUMUR_VERSION variable in rules from 2019.02.04-1 to 2019.12.22-1.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Mon, 23 Dec 2019 18:52:50 -0800

rumur (2019.02.04-1) unstable; urgency=medium

  * Initial release. Closes: #919220.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Mon, 4 Feb 2019 18:46:36 -0800

=== debian/tests/control ===
Tests: librumur-api rumur-ast-dump-model rumur-ast-dump-version rumur-model rumur-run-model rumur-version
Depends: build-essential, libfl-dev, libgmp-dev, python3 (>= 3.6), rumur
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/rumur-$1\.tar\.gz/ \
 https://github.com/Smattr/rumur/releases .*/v?(\d\S+)\.tar\.gz

## rumur 2020.02.17

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,9 +32,9 @@
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
 endif()
 
-add_subdirectory(ast-dump)
+add_subdirectory(murphi2xml)
 add_subdirectory(librumur)
 add_subdirectory(rumur)
 
 enable_testing()
-add_test(tests env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/ast-dump:$ENV{PATH} ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py)
+add_test(tests env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:$ENV{PATH} ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --jobs 1)

=== librumur/CMakeLists.txt ===
project(librumur LANGUAGES CXX)

find_package(BISON REQUIRED)
find_package(FLEX REQUIRED)

find_path(GMPXX_INCLUDE NAMES gmpxx.h PATHS ENV CPLUS_INCLUDE_PATH)
if(NOT GMPXX_INCLUDE)
  message(FATAL_ERROR "GMP headers not found")
endif()
find_library(GMP_LIBRARIES NAMES gmp PATHS ENV LIBRARY_PATH)
if(NOT GMP_LIBRARIES)
  message(FATAL_ERROR "libgmp not found")
endif()
find_library(GMPXX_LIBRARIES NAMES gmpxx PATHS ENV LIBRARY_PATH)
if(NOT GMPXX_LIBRARIES)
  message(FATAL_ERROR "libgmpxx not found")
endif()

bison_target(parser
  src/parser.yy
  ${CMAKE_CURRENT_BINARY_DIR}/parser.yy.cc
  COMPILE_FLAGS --warnings=all)
flex_target(lexer
  src/lexer.l
  ${CMAKE_CURRENT_BINARY_DIR}/lexer.l.cc)
add_flex_bison_dependency(lexer parser)

# Suppress warnings in generated code.
include(CheckCXXCompilerFlag)
set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "")
CHECK_CXX_COMPILER_FLAG(-Wsign-compare HAS_WARNING_SIGN_COMPARE)
if(HAS_WARNING_SIGN_COMPARE)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-sign-compare")
endif()
get_source_file_property(LEXER_COMPILE_FLAGS lexer.l.cc COMPILE_FLAGS)
CHECK_CXX_COMPILER_FLAG(-Wregister HAS_WARNING_REGISTER)
if(HAS_WARNING_REGISTER)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-register")
endif()
get_source_file_property(LEXER_COMPILE_FLAGS lexer.l.cc COMPILE_FLAGS)
CHECK_CXX_COMPILER_FLAG(-Wdeprecated-register HAS_WARNING_DEPRECATED_REGISTER)
if(HAS_WARNING_DEPRECATED_REGISTER)
  set_source_files_properties(lexer.l.cc PROPERTIES COMPILE_FLAGS "${LEXER_COMPILE_FLAGS} -Wno-deprecated-register")
endif()

add_custom_command(
  OUTPUT rumur-get-version.h
  COMMAND src/make-version.py ${CMAKE_CURRENT_BINARY_DIR}/rumur-get-version.h
  MAIN_DEPENDENCY src/make-version.py
  DEPENDS always_run
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

# Dummy output to make sure we always re-evaluate the version step above.
add_custom_command(
  OUTPUT always_run
  COMMAND /usr/bin/env true)

add_library(librumur
  ${CMAKE_CURRENT_BINARY_DIR}/rumur-get-version.h
  src/Boolean.cc
  src/Decl.cc
  src/except.cc
  src/Expr.cc
  src/Function.cc
  src/indexer.cc
  src/Model.cc
  src/Node.cc
  src/Number.cc
  src/parse.cc
  src/Property.cc
  src/resolve-symbols.cc
  src/Rule.cc
  src/Stmt.cc
  src/traverse.cc
  src/TypeExpr.cc
  src/validate.cc
  ${FLEX_lexer_OUTPUTS}
  ${BISON_parser_OUTPUTS})

target_include_directories(librumur
  PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>
  ${GMPXX_INCLUDE}
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR})
target_link_libraries(librumur PUBLIC ${GMPXX_LIBRARIES} ${GMP_LIBRARIES})

# Force the output to librumur.a instead of liblibrumur.a.
set_target_properties(librumur PROPERTIES PREFIX "")

# Clagged boiler plate to install a library.
install(TARGETS librumur EXPORT LibrumurConfig
  ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY include/ DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/location.hh
  ${CMAKE_CURRENT_BINARY_DIR}/parser.yy.hh
  ${CMAKE_CURRENT_BINARY_DIR}/position.hh
  ${CMAKE_CURRENT_BINARY_DIR}/rumur-get-version.h
  ${CMAKE_CURRENT_BINARY_DIR}/stack.hh
  DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/rumur)

export(TARGETS librumur FILE LibrumurConfig.cmake)

=== murphi2xml/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2xml.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/murphi2xml.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2xml
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.cc
  src/main.cc
  src/XMLPrinter.cc)

target_include_directories(murphi2xml
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2xml
  librumur)

# Compress manpages
add_custom_target(man-murphi2xml
  ALL
  DEPENDS murphi2xml.1.gz)
add_custom_command(
  OUTPUT murphi2xml.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2xml.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2xml.1.gz"
  MAIN_DEPENDENCY doc/murphi2xml.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2xml
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2xml.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== rumur/CMakeLists.txt ===
# Define resources.
add_custom_command(
  OUTPUT resources_manpage.cc
  COMMAND ../misc/xxd.py doc/rumur.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  MAIN_DEPENDENCY doc/rumur.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_includes.cc
  COMMAND ../misc/xxd.py resources/includes.c ${CMAKE_CURRENT_BINARY_DIR}/resources_includes.cc
  MAIN_DEPENDENCY resources/includes.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_header.cc
  COMMAND ../misc/xxd.py resources/header.c ${CMAKE_CURRENT_BINARY_DIR}/resources_header.cc
  MAIN_DEPENDENCY resources/header.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(rumur
  ${CMAKE_CURRENT_BINARY_DIR}/resources_includes.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_header.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  ../common/help.cc
  src/assume-statements-count.cc
  src/environ.cc
  src/generate-allocations.cc
  src/generate-cover-array.cc
  src/generate-decl.cc
  src/generate-expr.cc
  src/generate-function.cc
  src/generate-model.cc
  src/generate-print.cc
  src/generate-property.cc
  src/generate-quantifier.cc
  src/generate-stmt.cc
  src/has-start-state.cc
  src/log.cc
  src/main.cc
  src/max-simple-width.cc
  src/options.cc
  src/output.cc
  src/process.cc
  src/smt/define-enum-members.cc
  src/smt/define-records.cc
  src/smt/logic.cc
  src/smt/simplify.cc
  src/smt/solver.cc
  src/smt/translate.cc
  src/smt/typeexpr-to-smt.cc
  src/symmetry-reduction.cc
  src/utils.cc
  src/ValueType.cc)

target_include_directories(rumur
  PRIVATE
  src
  # FIXME: This is a hack to include generated headers from the library. We
  # really want to be able to stage these somewhere and talk about them here
  # as if they were just a regular, static exported header.
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(rumur
  librumur)

# Compress manpages
add_custom_target(man-rumur
  ALL
  DEPENDS rumur.1.gz rumur-run.1.gz)
add_custom_command(
  OUTPUT rumur.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/rumur.1 >"${CMAKE_CURRENT_BINARY_DIR}/rumur.1.gz"
  MAIN_DEPENDENCY doc/rumur.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT rumur-run.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/rumur-run.1 >"${CMAKE_CURRENT_BINARY_DIR}/rumur-run.1.gz"
  MAIN_DEPENDENCY doc/rumur-run.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS rumur
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(PROGRAMS
  ${CMAKE_CURRENT_SOURCE_DIR}/src/rumur-run
  DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/rumur.1.gz
  ${CMAKE_CURRENT_BINARY_DIR}/rumur-run.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== debian/changelog ===
rumur (2020.02.17-1) unstable; urgency=medium

  * New upstream release.

  * The installed binary that was previously called rumur-ast-dump is now called
    murphi2xml, due to an upstream change.

  * Update autopkgtest tests to now reference murphi2xml instead of
    rumur-ast-dump.

  * The build test suite now runs single threaded, due to an upstream change,
    partially addressing #951497.

  * Correct watch file to only scan for upstream releases, instead of also
    matching Debian tags.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Tue, 18 Feb 2020 18:15:52 -0800

=== debian/control ===
Source: rumur
Section: devel
Priority: optional
Maintainer: Matthew Fernandez <matthew.fernandez@gmail.com>
Build-Depends: debhelper-compat (= 12),
 bison (>= 3.0),
 cmake (>= 3.1),
 flex (>= 2.5.35),
 libfl-dev,
 libgmp-dev,
 python3 (>= 3.6),
 strace
Standards-Version: 4.5.0
Homepage: https://github.com/Smattr/rumur
Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
Vcs-Browser: https://github.com/Smattr/rumur.git
Rules-Requires-Root: no

Package: rumur
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: python3 (>= 3.6)
Description: model checker for the Murphi language
 Rumur is a model checker for use in the formal verification of finite state
 machines specified in the Murphi modelling language. It is based on a previous
 tool, CMurphi, and attempts to provide an approximate drop-in replacement for
 CMurphi.
 .
 Rumur works by reading an input file describing a collection of state variables
 and transition rules, from which it generates a C program to verify safety and
 security properties of this state machine. The generated verifier works by
 exhaustively exploring the state space, checking for violation of invariants or
 deadlocks.
 .
 In comparison to CMurphi, Rumur generates a verifier that runs significantly
 faster and uses less memory on large input problems. Rumur comes with an
 optional wrapper script, rumur-run, that streamlines the process of generating
 a verifier, compiling it, and then running it. This wrapper requires Python.

=== debian/tests/control ===
Tests: librumur-api murphi2xml-model murphi2xml-version rumur-model rumur-run-model rumur-version
Depends: build-essential, libfl-dev, libgmp-dev, python3 (>= 3.6), rumur
Restrictions: allow-stderr

## rumur 2020.07.28

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.1)
+cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
 
 project(rumur LANGUAGES CXX)
 
@@ -32,9 +32,13 @@
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
 endif()
 
+add_subdirectory(librumur)
+add_subdirectory(murphi2c)
+add_subdirectory(murphi2murphi)
 add_subdirectory(murphi2xml)
-add_subdirectory(librumur)
 add_subdirectory(rumur)
 
-enable_testing()
-add_test(tests env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:$ENV{PATH} ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --jobs 1)
+add_custom_target(check
+  COMMAND env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:$ENV{PATH}
+    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --jobs 1)
+add_dependencies(check murphi2c murphi2murphi murphi2xml rumur)

=== debian/changelog ===
rumur (2020.07.28-1) unstable; urgency=medium

  * New upstream release.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Thu, 30 Jul 2020 17:53:43 -0700

rumur (2020.05.27-1) unstable; urgency=medium

  * New upstream release.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sat, 30 May 2020 10:27:18 -0700

rumur (2020.05.18-1) unstable; urgency=medium

  * New upstream release.

  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse, thanks to Debian Janitor.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Wed, 20 May 2020 17:19:48 -0700

rumur (2020.04.26-1) unstable; urgency=medium

  * New upstream release.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Mon, 27 Apr 2020 17:14:28 -0700

rumur (2020.04.05-1) unstable; urgency=medium

  * New upstream release.

  * Add some autopkgtests for new binary, murphi2murphi.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 19 Apr 2020 09:08:53 -0700

rumur (2020.03.12-1) unstable; urgency=medium

  * New upstream release.

  * Add some autopkgtests for new binary, murphi2c.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 15 Mar 2020 10:27:19 -0700

## rumur 2020.12.20

=== CMakeLists.txt ===
--- 
+++ 
@@ -32,13 +32,22 @@
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
 endif()
 
+# if we have a new enough CMake to have FindPython3, check for it
+if(${CMAKE_VERSION} VERSION_GREATER 3.11)
+  find_package(Python3 REQUIRED COMPONENTS Interpreter)
+endif()
+
 add_subdirectory(librumur)
 add_subdirectory(murphi2c)
 add_subdirectory(murphi2murphi)
 add_subdirectory(murphi2xml)
 add_subdirectory(rumur)
+add_subdirectory(tests/murphi-comment-ls)
 
 add_custom_target(check
-  COMMAND env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:$ENV{PATH}
+  COMMAND env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:${CMAKE_CURRENT_BINARY_DIR}/tests/murphi-comment-ls:$ENV{PATH}
     ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --jobs 1)
 add_dependencies(check murphi2c murphi2murphi murphi2xml rumur)
+if(NOT CMAKE_CROSSCOMPILING)
+  add_dependencies(check murphi-comment-ls)
+endif()

=== librumur/CMakeLists.txt ===
--- 
+++ 
@@ -58,6 +58,7 @@
 add_library(librumur
   ${CMAKE_CURRENT_BINARY_DIR}/rumur-get-version.h
   src/Boolean.cc
+  src/Comment.cc
   src/Decl.cc
   src/except.cc
   src/Expr.cc

=== murphi2c/CMakeLists.txt ===
# Define resources.
add_custom_command(
  OUTPUT resources_manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2c.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  MAIN_DEPENDENCY doc/murphi2c.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_c_prefix.cc
  COMMAND ../misc/xxd.py resources/c_prefix.c ${CMAKE_CURRENT_BINARY_DIR}/resources_c_prefix.cc
  MAIN_DEPENDENCY resources/c_prefix.c
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})
add_custom_command(
  OUTPUT resources_h_prefix.cc
  COMMAND ../misc/xxd.py resources/h_prefix.h ${CMAKE_CURRENT_BINARY_DIR}/resources_h_prefix.cc
  MAIN_DEPENDENCY resources/h_prefix.h
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2c
  ${CMAKE_CURRENT_BINARY_DIR}/resources_c_prefix.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_h_prefix.cc
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  ../common/escape.cc
  ../common/help.cc
  src/check.cc
  src/CLikeGenerator.cc
  src/CodeGenerator.cc
  src/compares_complex_values.cc
  src/generate_c.cc
  src/generate_h.cc
  src/main.cc
  src/name_rules.cc
  src/options.cc)

target_include_directories(murphi2c
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2c
  librumur)

# Compress manpage
add_custom_target(man-murphi2c
  ALL
  DEPENDS murphi2c.1.gz)
add_custom_command(
  OUTPUT murphi2c.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2c.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2c.1.gz"
  MAIN_DEPENDENCY doc/murphi2c.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2c
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2c.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== murphi2murphi/CMakeLists.txt ===
# Define resources.
add_custom_command(
  OUTPUT resources_manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2murphi.1 ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  MAIN_DEPENDENCY doc/murphi2murphi.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2murphi
  ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
  ../common/help.cc
  src/DecomposeComplexComparisons.cc
  src/ExplicitSemicolons.cc
  src/main.cc
  src/options.cc
  src/Pipeline.cc
  src/Printer.cc
  src/RemoveLiveness.cc
  src/Stage.cc
  src/SwitchToIf.cc
  src/ToAscii.cc)

target_include_directories(murphi2murphi
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2murphi
  librumur)

# Compress manpage
add_custom_target(man-murphi2murphi
  ALL
  DEPENDS murphi2murphi.1.gz)
add_custom_command(
  OUTPUT murphi2murphi.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2murphi.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi.1.gz"
  MAIN_DEPENDENCY doc/murphi2murphi.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2murphi
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== rumur/CMakeLists.txt ===
--- 
+++ 
@@ -22,6 +22,7 @@
   ${CMAKE_CURRENT_BINARY_DIR}/resources_includes.cc
   ${CMAKE_CURRENT_BINARY_DIR}/resources_header.cc
   ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
+  ../common/escape.cc
   ../common/help.cc
   src/assume-statements-count.cc
   src/environ.cc
@@ -39,8 +40,10 @@
   src/log.cc
   src/main.cc
   src/max-simple-width.cc
+  src/optimise-field-ordering.cc
   src/options.cc
   src/output.cc
+  src/prints-scalarsets.cc
   src/process.cc
   src/smt/define-enum-members.cc
   src/smt/define-records.cc

=== tests/murphi-comment-ls/CMakeLists.txt ===
# this is only usable for testing if we are targeting the host machine
if(NOT CMAKE_CROSSCOMPILING)
  add_executable(murphi-comment-ls main.cc)
  target_include_directories(murphi-comment-ls PRIVATE
    ${CMAKE_CURRENT_BINARY_DIR}/../../librumur)
  target_link_libraries(murphi-comment-ls librumur)
endif()

=== debian/changelog ===
rumur (2020.12.20-1) unstable; urgency=medium

  * New upstream release.

  * Update Standards-Version from 4.5.0 to 4.5.1.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Tue, 22 Dec 2020 17:22:30 -0800

rumur (2020.09.06-1) unstable; urgency=medium

  * New upstream release.

  * Fix armel, armhf, mipsel, mips64el sandboxing. Closes: #969156.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Mon, 07 Sep 2020 09:43:16 -0700

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libgmp-dev,
  python3 (>= 3.6),
  strace
-Standards-Version: 4.5.0
+Standards-Version: 4.5.1
 Homepage: https://github.com/Smattr/rumur
 Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
 Vcs-Browser: https://github.com/Smattr/rumur.git

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/rumur-$1\.tar\.gz/ \
 https://github.com/Smattr/rumur/releases /Smattr/rumur/archive/v?(\d\S+)\.tar\.gz

## rumur 2022.08.20

=== librumur/CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,3 @@
-project(librumur LANGUAGES CXX)
-
 find_package(BISON REQUIRED)
 find_package(FLEX REQUIRED)
 
@@ -19,10 +17,11 @@
 bison_target(parser
   src/parser.yy
   ${CMAKE_CURRENT_BINARY_DIR}/parser.yy.cc
-  COMPILE_FLAGS --warnings=all)
+  COMPILE_FLAGS "--no-lines --warnings=all")
 flex_target(lexer
   src/lexer.l
-  ${CMAKE_CURRENT_BINARY_DIR}/lexer.l.cc)
+  ${CMAKE_CURRENT_BINARY_DIR}/lexer.l.cc
+  COMPILE_FLAGS "--noline")
 add_flex_bison_dependency(lexer parser)
 
 # Suppress warnings in generated code.
@@ -71,6 +70,7 @@
   src/Property.cc
   src/resolve-symbols.cc
   src/Rule.cc
+  src/sanitise_rule_names.cc
   src/Stmt.cc
   src/traverse.cc
   src/TypeExpr.cc
@@ -82,10 +82,13 @@
   PUBLIC
   $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
   $<INSTALL_INTERFACE:include>
-  ${GMPXX_INCLUDE}
   PRIVATE
   src
   ${CMAKE_CURRENT_BINARY_DIR})
+target_include_directories(librumur
+  SYSTEM PUBLIC
+  ${GMPXX_INCLUDE}
+)
 target_link_libraries(librumur PUBLIC ${GMPXX_LIBRARIES} ${GMP_LIBRARIES})
 
 # Force the output to librumur.a instead of liblibrumur.a.

=== murphi2murphi/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
   ${CMAKE_CURRENT_BINARY_DIR}/../librumur)
 
 target_link_libraries(murphi2murphi
+  PRIVATE
   librumur)
 
 # Compress manpage

=== murphi2xml/CMakeLists.txt ===
--- 
+++ 
@@ -17,6 +17,7 @@
   ${CMAKE_CURRENT_BINARY_DIR}/../librumur)
 
 target_link_libraries(murphi2xml
+  PRIVATE
   librumur)
 
 # Compress manpages

=== rumur/CMakeLists.txt ===
--- 
+++ 
@@ -65,6 +65,7 @@
   ${CMAKE_CURRENT_BINARY_DIR}/../librumur)
 
 target_link_libraries(rumur
+  PRIVATE
   librumur)
 
 # Compress manpages

=== debian/changelog ===
rumur (2022.08.20-1) unstable; urgency=medium

  * New upstream release.

  * Fix sandbox failures due to getrandom. Closes: #1017199.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sat, 20 Aug 2022 14:58:29 -0700

rumur (2022.03.05-1) unstable; urgency=medium

  * New upstream release.

  * Fix sandbox failures due to statx. Closes: #1004035.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 06 Mar 2022 11:42:05 -0800

rumur (2021.12.27-1) unstable; urgency=medium

  * New upstream release.

  * Fix sandbox failures due to newfstatat. Closes: #1002186.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Tue, 28 Dec 2021 09:14:44 -0800

rumur (2021.09.29-1) unstable; urgency=medium

  * New upstream release.

  * Update Standards-Version from 4.5.1 to 4.6.0.1.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sat, 02 Oct 2021 07:59:18 -0700

rumur (2021.08.28-1) unstable; urgency=medium

  * New upstream release.

  * A new binary, murphi2uclid, is now included.

  * Python build dependency and suggests have been relaxed from 3.6 to 3.4.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sat, 04 Sep 2021 09:11:03 -0700

=== debian/control ===
--- 
+++ 
@@ -3,14 +3,14 @@
 Priority: optional
 Maintainer: Matthew Fernandez <matthew.fernandez@gmail.com>
 Build-Depends: debhelper-compat (= 12),
- bison (>= 3.0),
- cmake (>= 3.1),
- flex (>= 2.5.35),
+ bison,
+ cmake,
+ flex,
  libfl-dev,
  libgmp-dev,
- python3 (>= 3.6),
+ python3,
  strace
-Standards-Version: 4.5.1
+Standards-Version: 4.6.1.0
 Homepage: https://github.com/Smattr/rumur
 Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
 Vcs-Browser: https://github.com/Smattr/rumur.git
@@ -19,7 +19,7 @@
 Package: rumur
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: python3 (>= 3.6)
+Suggests: python3
 Description: model checker for the Murphi language
  Rumur is a model checker for use in the formal verification of finite state
  machines specified in the Murphi modelling language. It is based on a previous

## rumur 2023.05.21

=== debian/changelog ===
rumur (2023.05.21-1) unstable; urgency=medium

  * New upstream release.
  * Fix build failures with GCC-13. Closes: #1037851.
  * Update Standards-Version from 4.6.0.1 to 4.6.2.
  * Relicense debian/ as Unlicense instead of GPL-3+.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sat, 22 Jul 2023 09:45:32 +1000

## rumur 2023.11.27

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1 FATAL_ERROR)

project(rumur LANGUAGES CXX)

# This seems to be some magic to get libraries to install correctly.
include(GNUInstallDirs)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -W -Wall -Wextra -Wformat=2 \
  -Wwrite-strings -Wmissing-declarations -Wshadow -Wundef")

# enable even more warnings if the compiler supports them
include(CheckCXXCompilerFlag)
CHECK_CXX_COMPILER_FLAG(-Wcast-qual HAS_WARNING_CAST_QUAL)
if(HAS_WARNING_CAST_QUAL)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-qual")
endif()
CHECK_CXX_COMPILER_FLAG(-Wcast-align HAS_WARNING_CAST_ALIGN)
if(HAS_WARNING_CAST_ALIGN)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wcast-align")
endif()
CHECK_CXX_COMPILER_FLAG(-Wlogical-op HAS_WARNING_LOGICAL_OP)
if(HAS_WARNING_LOGICAL_OP)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wlogical-op")
endif()
CHECK_CXX_COMPILER_FLAG(-Wstrict-aliasing=1 HAS_WARNING_STRICT_ALIASING_1)
if(HAS_WARNING_STRICT_ALIASING_1)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wstrict-aliasing=1")
endif()
CHECK_CXX_COMPILER_FLAG(-Wpointer-arith HAS_WARNING_POINTER_ARITH)
if(HAS_WARNING_POINTER_ARITH)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpointer-arith")
endif()

# Enable --as-needed, present on GNU ld on Linux, to minimise dependencies.
if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
endif()

# if we have a new enough CMake to have FindPython3, check for it
if(CMAKE_VERSION VERSION_GREATER 3.11)
  find_package(Python3 REQUIRED COMPONENTS Interpreter)
endif()

add_subdirectory(librumur)
add_subdirectory(murphi2c)
add_subdirectory(murphi2murphi)
add_subdirectory(murphi2uclid)
add_subdirectory(murphi2xml)
add_subdirectory(rumur)
add_subdirectory(tests/murphi-comment-ls)

add_custom_target(check
  COMMAND env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:${CMAKE_CURRENT_BINARY_DIR}/tests/murphi-comment-ls:$ENV{PATH}
    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --verbose)
add_dependencies(check murphi2c murphi2murphi murphi2uclid murphi2xml rumur)
if(NOT CMAKE_CROSSCOMPILING)
  add_dependencies(check murphi-comment-ls)
endif()

add_custom_target(format
  COMMAND git ls-files -z '**/*.cc' '**/*.h' |
    xargs -0 -- clang-format -i --style=file
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== murphi2c/CMakeLists.txt ===
--- 
+++ 
@@ -31,7 +31,6 @@
   src/generate_c.cc
   src/generate_h.cc
   src/main.cc
-  src/name_rules.cc
   src/options.cc)
 
 target_include_directories(murphi2c
@@ -40,6 +39,7 @@
   ${CMAKE_CURRENT_BINARY_DIR}/../librumur)
 
 target_link_libraries(murphi2c
+  PRIVATE
   librumur)
 
 # Compress manpage

=== murphi2uclid/CMakeLists.txt ===
add_custom_command(
  OUTPUT manpage.cc
  COMMAND ../misc/xxd.py doc/murphi2uclid.1 ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  MAIN_DEPENDENCY doc/murphi2uclid.1
  DEPENDS ../misc/xxd.py
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

add_executable(murphi2uclid
  ${CMAKE_CURRENT_BINARY_DIR}/manpage.cc
  ../common/help.cc
  src/check.cc
  src/codegen.cc
  src/main.cc
  src/pick_numeric_type.cc)

target_include_directories(murphi2uclid
  PRIVATE
  src
  ${CMAKE_CURRENT_BINARY_DIR}/../librumur)

target_link_libraries(murphi2uclid
  PRIVATE
  librumur)

add_custom_target(man-murphi2uclid
  ALL
  DEPENDS murphi2uclid.1.gz)
add_custom_command(
  OUTPUT murphi2uclid.1.gz
  COMMAND gzip -9 --no-name --to-stdout doc/murphi2uclid.1 >"${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid.1.gz"
  MAIN_DEPENDENCY doc/murphi2uclid.1
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

install(TARGETS murphi2uclid
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})
install(FILES
  ${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid.1.gz
  DESTINATION ${CMAKE_INSTALL_MANDIR}/man1)

=== debian/changelog ===
rumur (2023.11.27-1) unstable; urgency=medium

  * New upstream release.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 10 Dec 2023 11:26:23 +1100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
  libgmp-dev,
  python3,
  strace
-Standards-Version: 4.6.1.0
+Standards-Version: 4.6.2
 Homepage: https://github.com/Smattr/rumur
 Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
 Vcs-Browser: https://github.com/Smattr/rumur.git

=== debian/tests/control ===
Tests: librumur-api murphi2c-header murphi2c-source murphi2c-version murphi2murphi-basic murphi2murphi-version murphi2xml-model murphi2xml-version rumur-model rumur-run-model rumur-version
Depends: build-essential, libfl-dev, libgmp-dev, python3 (>= 3.6), rumur
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/rumur-$1\.tar\.gz/ \
 https://github.com/Smattr/rumur/tags .*/tags/v?(\d\S+)\.tar\.gz

## rumur 2024.05.07

=== debian/changelog ===
rumur (2024.05.07-1) unstable; urgency=medium

  * New upstream release.
  * Fix inaccurate libatomic checks in autopkgtests. Closes: #1018205.
  * Fix Vcs-Browser URL. Closes: #1018202.
  * Add libxml2-utils, z3 to Build-Depends.
  * Add z3 to Suggests.
  * Update Copyright from 2019 to 2019-2024.
  * Update debian-compat Build-Depends from 12 to 13.
  * Update Standards-Version from 4.6.2 to 4.7.0.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 19 May 2024 07:24:59 +1000

=== debian/control ===
--- 
+++ 
@@ -2,24 +2,26 @@
 Section: devel
 Priority: optional
 Maintainer: Matthew Fernandez <matthew.fernandez@gmail.com>
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
  bison,
  cmake,
  flex,
  libfl-dev,
  libgmp-dev,
+ libxml2-utils,
  python3,
- strace
-Standards-Version: 4.6.2
+ strace,
+ z3
+Standards-Version: 4.7.0
 Homepage: https://github.com/Smattr/rumur
 Vcs-Git: https://github.com/Smattr/rumur.git -b packaging/debian
-Vcs-Browser: https://github.com/Smattr/rumur.git
+Vcs-Browser: https://github.com/Smattr/rumur/tree/packaging/debian
 Rules-Requires-Root: no
 
 Package: rumur
 Architecture: any
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: python3
+Suggests: python3, z3
 Description: model checker for the Murphi language
  Rumur is a model checker for use in the formal verification of finite state
  machines specified in the Murphi modelling language. It is based on a previous

## rumur 2025.02.02

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,11 +1,22 @@
-cmake_minimum_required(VERSION 3.1 FATAL_ERROR)
+cmake_minimum_required(VERSION 3.2 FATAL_ERROR)
 
-project(rumur LANGUAGES CXX)
+project(rumur LANGUAGES C CXX)
 
 # This seems to be some magic to get libraries to install correctly.
 include(GNUInstallDirs)
 
-set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=c++11 -W -Wall -Wextra -Wformat=2 \
+set(CMAKE_C_STANDARD 99)
+set(CMAKE_C_STANDARD_REQUIRED ON)
+
+set(CMAKE_CXX_STANDARD 11)
+set(CMAKE_CXX_STANDARD_REQUIRED ON)
+
+# make asprintf(), mkostemp() prototypes visible
+if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+  add_compile_definitions(_GNU_SOURCE)
+endif()
+
+set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -W -Wall -Wextra -Wformat=2 \
   -Wwrite-strings -Wmissing-declarations -Wshadow -Wundef")
 
 # enable even more warnings if the compiler supports them
@@ -30,11 +41,71 @@
 if(HAS_WARNING_POINTER_ARITH)
   set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -Wpointer-arith")
 endif()
+include(CheckCCompilerFlag)
+CHECK_C_COMPILER_FLAG(-Wall HAS_C_WARNING_ALL)
+if(HAS_C_WARNING_ALL)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wall")
+endif()
+CHECK_C_COMPILER_FLAG(-Wextra HAS_C_WARNING_EXTRA)
+if(HAS_C_WARNING_EXTRA)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wextra")
+endif()
+CHECK_C_COMPILER_FLAG(-Wcast-align=strict HAS_C_WARNING_CAST_ALIGN_STRICT)
+if(HAS_C_WARNING_CAST_ALIGN_STRICT)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wcast-align=strict")
+endif()
+CHECK_C_COMPILER_FLAG(-Wformat=2 HAS_C_WARNING_FORMAT_2)
+if(HAS_C_WARNING_FORMAT_2)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat=2")
+endif()
+CHECK_C_COMPILER_FLAG(-Wformat-overflow=2 HAS_C_WARNING_FORMAT_OVERFLOW_2)
+if(HAS_C_WARNING_FORMAT_OVERFLOW_2)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wformat-overflow=2")
+endif()
+CHECK_C_COMPILER_FLAG(-Wlogical-op HAS_C_WARNING_LOGICAL_OP)
+if(HAS_C_WARNING_LOGICAL_OP)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wlogical-op")
+endif()
+CHECK_C_COMPILER_FLAG(-Wmissing-prototypes HAS_C_WARNING_MISSING_PROTOTYPES)
+if(HAS_C_WARNING_MISSING_PROTOTYPES)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wmissing-prototypes")
+endif()
+CHECK_C_COMPILER_FLAG(-Wstrict-aliasing=1 HAS_C_WARNING_STRICT_ALIASING_1)
+if(HAS_C_WARNING_STRICT_ALIASING_1)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wstrict-aliasing=1")
+endif()
+CHECK_C_COMPILER_FLAG(-Wpointer-arith HAS_C_WARNING_POINTER_ARITH)
+if(HAS_C_WARNING_POINTER_ARITH)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wpointer-arith")
+endif()
+CHECK_C_COMPILER_FLAG(-Wshadow HAS_C_WARNING_SHADOW)
+if(HAS_C_WARNING_SHADOW)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wshadow")
+endif()
+CHECK_C_COMPILER_FLAG(-Wundef HAS_C_WARNING_UNDEF)
+if(HAS_C_WARNING_UNDEF)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wundef")
+endif()
+CHECK_C_COMPILER_FLAG(-Wwrite-strings HAS_C_WARNING_WRITE_STRINGS)
+if(HAS_C_WARNING_WRITE_STRINGS)
+  set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -Wwrite-strings")
+endif()
+
+# make mkostemp(), pipe2() prototype visible
+if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
+  add_definitions(-D_GNU_SOURCE)
+endif()
 
 # Enable --as-needed, present on GNU ld on Linux, to minimise dependencies.
 if(CMAKE_SYSTEM_NAME STREQUAL "Linux")
   set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,--as-needed")
   set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,--as-needed")
+endif()
+
+if(APPLE)
+  list(APPEND CMAKE_INSTALL_RPATH "@executable_path/../${CMAKE_INSTALL_LIBDIR}")
+else()
+  list(APPEND CMAKE_INSTALL_RPATH "\$ORIGIN/../${CMAKE_INSTALL_LIBDIR}")
 endif()
 
 # if we have a new enough CMake to have FindPython3, check for it
@@ -43,22 +114,33 @@
 endif()
 
 add_subdirectory(librumur)
+add_subdirectory(murphi-format)
 add_subdirectory(murphi2c)
 add_subdirectory(murphi2murphi)
+add_subdirectory(murphi2smv)
 add_subdirectory(murphi2uclid)
 add_subdirectory(murphi2xml)
 add_subdirectory(rumur)
+add_subdirectory(share)
 add_subdirectory(tests/murphi-comment-ls)
 
 add_custom_target(check
-  COMMAND env PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:${CMAKE_CURRENT_BINARY_DIR}/tests/murphi-comment-ls:$ENV{PATH}
-    ${CMAKE_CURRENT_SOURCE_DIR}/tests/run-tests.py --verbose)
-add_dependencies(check murphi2c murphi2murphi murphi2uclid murphi2xml rumur)
+  COMMAND env
+    PATH=${CMAKE_CURRENT_BINARY_DIR}/rumur:${CMAKE_CURRENT_BINARY_DIR}/murphi-format:${CMAKE_CURRENT_BINARY_DIR}/murphi2c:${CMAKE_CURRENT_BINARY_DIR}/murphi2murphi:${CMAKE_CURRENT_BINARY_DIR}/murphi2uclid:${CMAKE_CURRENT_BINARY_DIR}/murphi2xml:${CMAKE_CURRENT_BINARY_DIR}/tests/murphi-comment-ls:$ENV{PATH}
+    CPLUS_INCLUDE_PATH=${CMAKE_CURRENT_SOURCE_DIR}/librumur/include:${CMAKE_CURRENT_BINARY_DIR}/librumur
+    LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR}/librumur
+    LD_LIBRARY_PATH=${CMAKE_CURRENT_BINARY_DIR}/librumur
+    python3 -m pytest --capture=no --override-ini=cache_dir=${CMAKE_CURRENT_BINARY_DIR} --verbose --verbose ${CMAKE_CURRENT_SOURCE_DIR}/tests/tests.py
+  USES_TERMINAL
+)
+add_dependencies(check
+  murphi-format murphi2c murphi2murphi murphi2uclid murphi2xml rumur
+)
 if(NOT CMAKE_CROSSCOMPILING)
   add_dependencies(check murphi-comment-ls)
 endif()
 
 add_custom_target(format
-  COMMAND git ls-files -z '**/*.cc' '**/*.h' |
+  COMMAND git ls-files -z '**/*.c' '**/*.cc' '**/*.h' |
     xargs -0 -- clang-format -i --style=file
   WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR})

=== murphi2murphi/CMakeLists.txt ===
--- 
+++ 
@@ -8,7 +8,7 @@
 
 add_executable(murphi2murphi
   ${CMAKE_CURRENT_BINARY_DIR}/resources_manpage.cc
-  ../common/help.cc
+  ../common/help.c
   src/DecomposeComplexComparisons.cc
   src/ExplicitSemicolons.cc
   src/main.cc

=== share/CMakeLists.txt ===
install(
  FILES
    _list
    _set
    README.rst
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.01.04
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.01.05
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)
install(DIRECTORY v2025.02.02
  DESTINATION ${CMAKE_INSTALL_DATAROOTDIR}/rumur/lib
)

=== debian/changelog ===
rumur (2025.02.02-1) unstable; urgency=medium

  * New upstream release.
  * Add python3-pytest as a build dependency.
  * Add a Lintian override for a descriptive file installed outside doc.
  * python3 moved from Suggests to Depends.

 -- Matthew Fernandez <matthew.fernandez@gmail.com>  Sun, 02 Feb 2025 06:44:25 +1100

=== debian/control ===
--- 
+++ 
@@ -10,6 +10,7 @@
  libgmp-dev,
  libxml2-utils,
  python3,
+ python3-pytest,
  strace,
  z3
 Standards-Version: 4.7.0
@@ -20,8 +21,8 @@
 
 Package: rumur
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}
-Suggests: python3, z3
+Depends: python3, ${shlibs:Depends}, ${misc:Depends}
+Suggests: z3
 Description: model checker for the Murphi language
  Rumur is a model checker for use in the formal verification of finite state
  machines specified in the Murphi modelling language. It is based on a previous
